# TensorFlow In Use

This page highlights TensorFlow models in real world use.


## Model zoo

Please visit our collection of TensorFlow models in the
[TensorFlow Zoo](https://github.com/tensorflow/models).

If you have built a model with TensorFlow, please consider publishing it in
the Zoo.


## Current uses

This section describes some of the current uses of the TensorFlow system.

> If you are using TensorFlow for research, for education, or for production
> usage in some product, we would love to add something about your usage here.
> Please feel free to email us a brief description of how you're using
> TensorFlow, or even better, send us a pull request to add an entry to this
> file.

* **RankBrain**
<ul>
   <li>**Organization**: Google</li>
   <li> **Domain**: Information Retrieval</li>
   <li> **Description**:  A large-scale deployment of deep neural nets for search ranking on www.google.com.</li>
   <li> **More info**: ["Google Turning Over Its Lucrative Search to AI Machines"](http://www.bloomberg.com/news/articles/2015-10-26/google-turning-its-lucrative-web-search-over-to-ai-machines)</li>
</ul>

* **Inception Image Classification Model**
<ul>
   <li> **Organization**: Google</li>
   <li> **Description**: Baseline model and follow on research into highly accurate computer vision models, starting with the model that won the 2014 Imagenet image classification challenge</li>
   <li> **More Info**: Baseline model described in [Arxiv paper](http://arxiv.org/abs/1409.4842)</li>
</ul>

* **SmartReply**
<ul>
  <li> **Organization**: Google</li>
  <li> **Description**: Deep LSTM model to automatically generate email responses</li>
  <li> **More Info**: [Google research blog post](http://googleresearch.blogspot.com/2015/11/computer-respond-to-this-email.html)</li>
</ul>

* **Massively Multitask Networks for Drug Discovery**
<ul>
  <li> **Organization**: Google and Stanford University</li>
  <li> **Domain**: Drug discovery</li>
  <li> **Description**:  A deep neural network model for identifying promising drug candidates.</li>
  <li> **More info**: [Arxiv paper](http://arxiv.org/abs/1502.02072)</li>
</ul>

* **On-Device Computer Vision for OCR**
<ul>
  <li> **Organization**: Google</li>
  <li> **Description**: On-device computer vision model to do optical character recognition to enable real-time translation.</li>
  <li> **More info**: [Google Research blog post](http://googleresearch.blogspot.com/2015/07/how-google-translate-squeezes-deep.html)</li>
</ul>
