# Learn (contrib)
[TOC]

High level API for learning with TensorFlow.

## Estimators

Train and evaluate TensorFlow models.

*   @{tf.contrib.learn.BaseEstimator}
*   @{tf.contrib.learn.Estimator}
*   @{tf.contrib.learn.Trainable}
*   @{tf.contrib.learn.Evaluable}
*   @{tf.contrib.learn.KMeansClustering}
*   @{tf.contrib.learn.ModeKeys}
*   @{tf.contrib.learn.ModelFnOps}
*   @{tf.contrib.learn.MetricSpec}
*   @{tf.contrib.learn.PredictionKey}
*   @{tf.contrib.learn.DNNClassifier}
*   @{tf.contrib.learn.DNNRegressor}
*   @{tf.contrib.learn.DNNLinearCombinedRegressor}
*   @{tf.contrib.learn.DNNLinearCombinedClassifier}
*   @{tf.contrib.learn.LinearClassifier}
*   @{tf.contrib.learn.LinearRegressor}
*   @{tf.contrib.learn.LogisticRegressor}

## Distributed training utilities
*   @{tf.contrib.learn.Experiment}
*   @{tf.contrib.learn.ExportStrategy}
*   @{tf.contrib.learn.TaskType}

## Graph actions

Perform various training, evaluation, and inference actions on a graph.

*   @{tf.train.NanLossDuringTrainingError}
*   @{tf.contrib.learn.RunConfig}
*   @{tf.contrib.learn.evaluate}
*   @{tf.contrib.learn.infer}
*   @{tf.contrib.learn.run_feeds}
*   @{tf.contrib.learn.run_n}
*   @{tf.contrib.learn.train}

## Input processing

Queue and read batched input data.

*   @{tf.contrib.learn.extract_dask_data}
*   @{tf.contrib.learn.extract_dask_labels}
*   @{tf.contrib.learn.extract_pandas_data}
*   @{tf.contrib.learn.extract_pandas_labels}
*   @{tf.contrib.learn.extract_pandas_matrix}
*   @{tf.contrib.learn.infer_real_valued_columns_from_input}
*   @{tf.contrib.learn.infer_real_valued_columns_from_input_fn}
*   @{tf.contrib.learn.read_batch_examples}
*   @{tf.contrib.learn.read_batch_features}
*   @{tf.contrib.learn.read_batch_record_features}

Export utilities

*   @{tf.contrib.learn.build_parsing_serving_input_fn}
*   @{tf.contrib.learn.ProblemType}
