# Python API Guides

*   [Asserts and boolean checks](check_ops.md)
*   [Building Graphs](framework.md)
*   [Constants, Sequences, and Random Values](constant_op.md)
*   [Control Flow](control_flow_ops.md)
*   [Data IO (Python functions)](python_io.md)
*   [Exporting and Importing a MetaGraph](meta_graph.md)
*   [Higher Order Functions](functional_ops.md)
*   [Histograms](histogram_ops.md)
*   [Images](image.md)
*   [Inputs and Readers](io_ops.md)
*   [Math](math_ops.md)
*   [Neural Network](nn.md)
*   [Reading data](reading_data.md)
*   [Running Graphs](client.md)
*   [Sparse Tensors](sparse_ops.md)
*   [Spectral Functions](spectral_ops.md)
*   [Strings](string_ops.md)
*   [Summary Operations](summary.md)
*   [TensorFlow Debugger](tfdbg.md)
*   [Tensor Handle Operations](session_ops.md)
*   [Tensor Transformations](array_ops.md)
*   [Testing](test.md)
*   [Training](train.md)
*   [Variables](state_ops.md)
*   [Wraps python functions](script_ops.md)
*   [BayesFlow Entropy (contrib)](contrib.bayesflow.entropy.md)
*   [BayesFlow Monte Carlo (contrib)](contrib.bayesflow.monte_carlo.md)
*   [BayesFlow Stochastic Graph (contrib)](contrib.bayesflow.stochastic_graph.md)
*   [BayesFlow Stochastic Tensors (contrib)](contrib.bayesflow.stochastic_tensor.md)
*   [BayesFlow Variational Inference (contrib)](contrib.bayesflow.variational_inference.md)
*   [Copying Graph Elements (contrib)](contrib.copy_graph.md)
*   [CRF (contrib)](contrib.crf.md)
*   [FFmpeg (contrib)](contrib.ffmpeg.md)
*   [Framework (contrib)](contrib.framework.md)
*   [Graph Editor (contrib)](contrib.graph_editor.md)
*   [Integrate (contrib)](contrib.integrate.md)
*   [Layers (contrib)](contrib.layers.md)
*   [Learn (contrib)](contrib.learn.md)
*   [Linear Algebra (contrib)](contrib.linalg.md)
*   [Losses (contrib)](contrib.losses.md)
*   [Metrics (contrib)](contrib.metrics.md)
*   [Optimization (contrib)](contrib.opt.md)
*   [Random variable transformations (contrib)](contrib.distributions.bijectors.md)
*   [RNN and Cells (contrib)](contrib.rnn.md)
*   [Seq2seq Library (contrib)](contrib.seq2seq.md)
*   [Signal Processing (contrib)](contrib.signal.md)
*   [Staging (contrib)](contrib.staging.md)
*   [Statistical Distributions (contrib)](contrib.distributions.md)
*   [Training (contrib)](contrib.training.md)
*   [Utilities (contrib)](contrib.util.md)
